#
# spec file for package midgard (Version 1.4)
# 
# Copyright  (c)  2001  SuSE GmbH  Nuernberg, Germany.
# This file and all modifications and additions to the pristine
# package are under the same license as the package itself.
# 
# please send bugfixes or comments to feedback@suse.de.
#

# neededforbuild  apache apache-devel expat freetype2 freetype2-devel gd gd-devel gdbm glib glib-devel imap libjpeg libpng libtiff libz mm mysql-devel mysql-shared openldap2 openldap2-client openldap2-devel postgresql-devel postgresql-libs xf86
# usedforbuild    aaa_base aaa_dir apache apache-devel autoconf automake base bash bindutil binutils bison bzip compress cpio cpp cracklib cyrus-sasl db devs diffutils e2fsprogs expat file fileutils findutils flex freetype2 freetype2-devel gawk gcc gd gd-devel gdbm gdbm-devel gettext glib glib-devel glibc glibc-devel gpm gppshare grep groff gzip imap kbd less libjpeg libpng libtiff libtool libz m4 make man mktemp mm modutils mysql-devel mysql-shared ncurses ncurses-devel net-tools netcfg openldap2 openldap2-client openldap2-devel pam pam-devel patch perl postgresql-devel postgresql-libs ps rcs readline rpm sendmail sh-utils shadow strace syslogd sysvinit texinfo textutils timezone unzip util-linux vim xdevel xf86 xshared

Name:         midgard
%define apache_version    %(rpm -q --queryformat '%%{version}' apache)
%define apache_sysconfdir %(apxs -q SYSCONFDIR)
%define apache_libexecdir %(apxs -q LIBEXECDIR)
%define apache_includedir %(apxs -q INCLUDEDIR)
%define apache_serverroot %(apxs -q PREFIX)
%define apache_docroot    %(apxs -q PREFIX)/htdocs
Copyright:    distributable
Summary:      Web application development and publishing platform
Group:        Networking/Daemons
Requires:     apache = %{apache_version}
Conflicts:    mod_php mod_php4
Autoreqprov:  on
Version:      1.4
Release:      147
Source0:      midgard-php-%{version}.tar.bz2
Source1:      midgard-lib-%{version}.tar.bz2
Source2:      mod_midgard-%{version}.tar.bz2
Source3:      midgard-data-%{version}.tar.bz2
Source4:      midgard-SuSEconfig
#Patch0:       php-3.0.12.dif
Patch:	      midgard-lib-%{version}.dif
Patch1:	      mod_midgard-%{version}.dif
Patch2:       midgard-lib-ia64.dif
Patch3:       midgard-php-ia64.dif
Patch4:      midgard-php-%{version}.dif
URL:          http://www.midgard-project.org/
BuildRoot:    /var/tmp/midgard-%{version}-root

%description
Midgard is a freely-available Web application development and
publishing platform based on the popular PHP scripting language. It is
an Open Source development project, giving you the freedom to create
your solutions in an open environment. Midgard is the tool for
creating, modifying and maintaining dynamic database-enabled web
services.
This package includes patched php3-3.0.12. For additional
information about php3 see /usr/share/doc/packages/mod_php.
You can try midgard test site at http://yourhostname:8099.
You can try midgard admin site at http://yourhostname:8101.
Default admin user name is admin, password is password.

SuSE series: n

%prep
%setup -q -n midgard-php-%{version} -a 1 -a 2 -a 3
%patch3
%patch4
cd midgard-lib-%{version}
%patch
%patch2
libtoolize --force
aclocal
automake
autoconf
cd ..
cd mod_midgard-%{version}
%patch1
libtoolize --force
aclocal
autoconf
cd ..
ln -sf /usr/include/mysql /usr/local/include/mysql

%build
# midgard-lib
cd midgard-lib-%{version}
%{?suse_update_config:%{suse_update_config -f}}
./configure
make
test -d .libs && mv .libs lib
test -d src/.libs && mv src/.libs lib
mkdir include
mv midgard.h include
mv mgd_apache.h include
cd ..
#
# mod_midgard
cd mod_midgard-%{version}
%{?suse_update_config:%{suse_update_config -f}}
#LIB="-L/usr/lib/mysql -lmidgard -lmysqlclient" \
#  LDFLAGS="-L/usr/lib/mysql -lmidgard -lmysqlclient" \
LIB="-L/usr/lib/mysql -lmysqlclient" \
  LDFLAGS="-L/usr/lib/mysql -lmysqlclient" \
  ./configure --with-midgard=`pwd`/../midgard-lib-%{version} --with-apache=%{apache_sysconfdir}
make DEF='-DMIDGARD_RPM_RELEASE=\"\\\"${RPM_PACKAGE_RELEASE}\\\"\"' CC=gcc APXS=apxs
cd ..
#
# midgard-php
%{?suse_update_config:%{suse_update_config -f}}
autoconf
cat configure | \
	sed -e 's+if test $php_cv_cc_rpath =+if test ! $php_cv_cc_rpath =+' > tmp_file
mv tmp_file configure
chmod 755 configure
rm -f config.cache
# 
CFLAGS="-I. -I/usr/include/gd/ -I/usr/include/pgsql/" \
	LDFLAGS="$LDFLAGS -L/usr/lib/mysql -L/usr/X11R6/lib/ -ltiff -DEAPI" \
        ./configure \
	--with-pgsql=/usr/lib/pgsql \
	--with-mysql=yes \
        --enable-safe-mode --enable-sysvsem --enable-sysvshm \
	--enable-track-vars --disable-magic-quotes \
	--enable-memory-limit \
%ifnarch alpha
	--enable-versioning \
%endif
	--enable-debugger \
        --enable-bcmath --with-zlib=yes \
        --with-ttf --with-imap=yes --with-ldap=yes \
        --with-xml --with-gd=yes \
	--with-yp --with-jpeg-dir --with-tiff-dir \
        --with-config-file-path=%{apache_sysconfdir} \
	--with-apxs="%{_sbindir}/apxs -ltiff -lnsl -lpng" \
        --with-exec-dir=%{apache_libexecdir}/bin \
        --with-apache=`pwd`/.. %{_target_cpu}-suse-linux-gnu \
	--with-midgard=`pwd`/midgard-lib-%{version} --with-mysql=/usr/
%ifarch sparc
make "CFLAGS_SHLIB = -fPIC -DSHARED_MODULE";
pushd convertor ;
make "CFLAGS_SHLIB = -fPIC -DSHARED_MODULE";
popd ;
%else
make ;
pushd convertor ;
make ;
popd ;
%endif

%install
rm -rf $RPM_BUILD_ROOT
#
# midgard-lib
( cd midgard-lib-%{version}
  install -d $RPM_BUILD_ROOT/usr/lib
  cp -a lib/*.so* $RPM_BUILD_ROOT/usr/lib 
  mv ChangeLog ../ChangeLog.midgard-lib
  mv NEWS ../NEWS.midgard-lib
  mv README ../README.midgard-lib
  mv AUTHORS ../)
#
# mod_midgard
( cd mod_midgard-%{version}
  install -d $RPM_BUILD_ROOT/%{apache_libexecdir}
  install -m 755 mod_midgard.so $RPM_BUILD_ROOT/%{apache_libexecdir}
  install -d $RPM_BUILD_ROOT/%{apache_docroot}/midgard
  install -m 644 midgard-root.php3 $RPM_BUILD_ROOT/%{apache_docroot}/midgard
  mv ChangeLog ../ChangeLog.mod_midgard
  mv NEWS ../NEWS.mod_midgard
  mv README ../README.mod_midgard
  )
#
# midgard-php
mv libphp3.so libphp3-midgard.so
install -s libphp3-midgard.so $RPM_BUILD_ROOT/%{apache_libexecdir}
mv ChangeLog ChangeLog.midgard-php3
#
# midgard-data
( cd midgard-data-%{version}
  install -d $RPM_BUILD_ROOT/%{apache_docroot}
  install -d $RPM_BUILD_ROOT/usr/lib/midgard
  install -m 644 midgard*.sql $RPM_BUILD_ROOT/usr/lib/midgard
  install -m 644 midgard-en.sql $RPM_BUILD_ROOT/usr/lib/midgard/midgard.sql
  cp -ar example $RPM_BUILD_ROOT/%{apache_docroot}
  cp -ar midgard/images $RPM_BUILD_ROOT/%{apache_docroot})
install -d $RPM_BUILD_ROOT%{apache_sysconfdir}/midgard
touch $RPM_BUILD_ROOT%{apache_sysconfdir}/midgard/midgard.conf
install -d $RPM_BUILD_ROOT/sbin/conf.d
install $RPM_SOURCE_DIR/midgard-SuSEconfig $RPM_BUILD_ROOT/sbin/conf.d/SuSEconfig.midgard
cat >>AUTHORS <<EOF
This package was derived from php3-3.0.12. For additional informations
see /usr/doc/packages/mod_php.
EOF
# test if Apache is able to load midgard modules
cat %{apache_sysconfdir}/httpd.conf | sed "s+Include %{apache_sysconfdir}/%{name}/%{name}.conf+Include $PWD/%{name}.conf+" > httpd.conf
cat >%{name}.conf <<EOF
LoadModule midgard_module $RPM_BUILD_ROOT%{apache_libexecdir}/mod_midgard.so
LoadModule php3_module $RPM_BUILD_ROOT%{apache_libexecdir}/libphp3-midgard.so
AddModule mod_midgard.c
AddModule mod_php3.c
EOF
DBROOT=/dev/null LD_LIBRARY_PATH=$RPM_BUILD_ROOT/usr/lib/ %{_sbindir}/httpd -f `pwd`/httpd.conf -t -D MIDGARD || exit 1
install -d $RPM_BUILD_ROOT/%{apache_sysconfdir}/modules/   || mkdir -p $RPM_BUILD_ROOT/%{apache_sysconfdir}/modules/
install -d $RPM_BUILD_ROOT/%{_var}/adm/fillup-templates/   || mkdir -p $RPM_BUILD_ROOT/%{_var}/adm/fillup-templates/
echo "#" > apache.rc.config
echo "# enable the %{name} module (yes|no)" >> apache.rc.config
echo "#" >> apache.rc.config
echo "HTTPD_SEC_MOD_MIDGARD=no" >> apache.rc.config
echo ""  >> apache.rc.config
echo -e "Variable:HTTPD_SEC_MOD_MIDGARD\nText:Midgard\nInclude: %{apache_sysconfdir}/%{name}/%{name}.conf\n" \
        > $RPM_BUILD_ROOT/%{apache_sysconfdir}/modules/%{name}
install -m 644 apache.rc.config $RPM_BUILD_ROOT/%{_var}/adm/fillup-templates/apache-%{name}.rc.config

%post
echo -n "Updating etc/rc.config.d/apache.rc.config..."
if [ -x bin/fillup ] ; then
        test -e etc/rc.config.d/apache.rc.config || touch etc/rc.config.d/apache.rc.config
        bin/fillup -q -d = etc/rc.config.d/apache.rc.config var/adm/fillup-templates/apache-%{name}.rc.config
        echo " Done."
else
        echo
        echo "ERROR: fillup not found. This should not happen. Please compare"
        echo "etc/rc.config.d/apache.rc.config and "
        echo "var/adm/fillup-templates/apache-%{name}.rc.config and update by hand."
fi

%preun
if [ "$1" = 0 ]; then
  MIDGARD_UNINSTALL=yes /sbin/conf.d/SuSEconfig.midgard
fi

%clean
rm -rf $RPM_BUILD_ROOT

%files
%doc AUTHORS 
%doc ChangeLog.midgard-lib NEWS.midgard-lib README.midgard-lib
%doc ChangeLog.mod_midgard NEWS.mod_midgard README.mod_midgard
/usr/lib/libmidgard.so*
/usr/lib/midgard/
/sbin/conf.d/SuSEconfig.midgard
%dir %{apache_sysconfdir}/midgard/
%config %ghost %{apache_sysconfdir}/midgard/midgard.conf
%{apache_sysconfdir}/modules/%{name}
%{_var}/adm/fillup-templates/apache-%{name}.rc.config
%{apache_libexecdir}/*
%{apache_docroot}/midgard/
%{apache_docroot}/images
%{apache_docroot}/example

%changelog -n midgard
* Wed Aug 22 2001 - ro@suse.de
- removed another hardcoded reference for pdflib in specfile
* Wed Aug 22 2001 - ro@suse.de
- removed pdflib from neededforbuild (license problems)
* Thu Jul 26 2001 - kukuk@suse.de
- fix needed for build
* Fri Jun 22 2001 - ro@suse.de
- fixed for new autoconf
* Wed Jun 06 2001 - pblaha@suse.cz
- fix cast pointer on ia64
* Thu May 17 2001 - pblaha@suse.cz
- rename in midgard.spec:%%ifarch ! axp  to alpha
* Fri May 04 2001 - pblaha@suse.cz
- add  AddType application/x-httpd-php3 .php3 in SuSEconfig.midgard
* Tue May 01 2001 - kukuk@suse.de
- disable adabas support
* Wed Apr 04 2001 - rolf@suse.de
- added /var/adm/fillup-templates/apache-midgard.rc.config
- added /etc/httpd/modules/midgard
- added Conflicts: mod_php mod_php4
* Thu Mar 22 2001 - ro@suse.de
- update to 1.4
- use freetype2
* Thu Mar 15 2001 - ro@suse.de
- changed to openldap2
* Thu Mar 15 2001 - ro@suse.de
- fixed neededforbuild for openldap
* Fri Feb 23 2001 - ro@suse.de
- changed neededforbuild <apache> to <apache apache-devel>
* Thu Jan 11 2001 - pblaha@suse.cz
- fix bug describied http://midgard.teamlinux.de/news/9133.html
- move midgard-root.php3 to /usr/local/httpd/htdocs/midgard/
- update SuSEconfig.midgard
* Wed Nov 29 2000 - ro@suse.de
- changed neededforbuild <pg_lib> to <postgresql-lib>
* Wed Nov 15 2000 - ro@suse.de
- fixed neededforbuild gdlib -> gd gd-devel
* Mon Nov 06 2000 - ro@suse.de
- fixed neededforbuild
* Mon Sep 18 2000 - bubnikv@suse.cz
- fixed path in generation of midgard.conf in SuSEconfig.midgard
- added midgard.conf as ghost configuration file to file list
* Tue Jul 25 2000 - bubnikv@suse.cz
- /usr/lib/midgard{.so,so.x} should be links; fixed
- added test, if apache is able to load midgard modules
* Tue Jul 18 2000 - bubnikv@suse.cz
- put -I. as the first include path for midgard-php3 compilation
  (it took config.h from other place before)
* Mon Jul 10 2000 - bubnikv@suse.cz
- return 0 changed to exit 0 at the end of SuSEconfig.midgard
* Fri Jul 07 2000 - kukuk@suse.de
- Fix Requires and need for build
* Thu Jun 29 2000 - ro@suse.de
- changed requires pg_ifa -> postgres
* Mon Jun 26 2000 - uli@suse.de
- midgard-lib needs to link libm (fixes problem on PPC, and most
  probably on SPARC, too)
* Fri Jun 16 2000 - bubnikv@suse.cz
- fixed for new postgres
* Fri May 26 2000 - bubnikv@suse.cz
- sorted
* Thu May 11 2000 - bubnikv@suse.cz
- modified SuSEconfig.midgard
* Fri Apr 28 2000 - bubnikv@suse.cz
- added package
